#!/usr/bin/mumps
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+
#+     Mumps Bioinformatics Software Library
#+     Copyright (C) 2004, 2005, 2006, 2008 by Kevin C. O'Kane
#+
#+     Kevin C. O'Kane
#+     anamfianna@earthlink.net
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# cluster.mps March 20, 2008

        kill ^clstr
        kill ^x
        kill ^ct

        open 1:"tmp,new"
        use 1
        for d1="":$order(^dd(d1)):"" do
        . for d2=d1:$order(^dd(d1,d2)):"" do
        .. if ^dd(d1,d2)<0.7 quit
        .. write ^dd(d1,d2)," ",d1," ",d2,!
        close 1
        set %=$zsystem("sort -n -r < tmp > tmp.sorted")
        open 1:"tmp.sorted,old"
        set c=1
        for  do
        . use 1
        . read a  // correlation doc1 doc2
        . if '$test break
        . set score=$p(a," ",1)
        . set seq1=$p(a," ",2)
        . set seq2=$p(a," ",3)
        . if seq1=seq2 quit
        . set f=1

# ^x() is a two dimensional array that contains, at the second level,
# a list of clusters to which the document number (seq1) belongs
# ^cluster() is the cluster matrix.  Each row (s) is a cluster
# numbered 1,2,3 ... The second level is a list of the document
# numbers of those documents in the cluster. The following
# code runs thru all the clusters first for doc1 (seq1) and
# adds seq2 (doc2) to those clusters doc1 belongs to.  It
# repeats the process for seq2 (doc2).  If a doc pair are not
# assigned to some cluster (f=1), they are assigned to a new
# cluster and the cluster number is incremented (c)

        . if $d(^x(seq1)) for s="":$order(^x(seq1,s)):"" do
        .. set ^clstr(s,seq2)=""
        .. set ^x(seq2,s)=""
        .. set f=0

        . if $d(^x(seq2)) for s="":$order(^x(seq2,s)):"" do
        .. set ^clstr(s,seq1)=""
        .. set ^x(seq1,s)=""
        .. set f=0

        . if f do
        .. set ^clstr(c,seq1)="" set ^x(seq1,c)=""
        .. set ^clstr(c,seq2)="" set ^x(seq2,c)=""
        .. set c=c+1

# print the clusters

        close 1
        use 5
        for cx="":$order(^clstr(cx)):"" do
        . write "cluster ",cx,!
        . for seq1="":$order(^clstr(cx,seq1)):"" do
        .. use 5 write seq1,?8,^title(seq1),!
        .. set ^ct(cx,seq1)=""
        . write !

