#!/usr/bin/mumps
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+
#+     Mumps Bioinformatics Software Library
#+     Copyright (C) 2004, 2005, 2006, 2008 by Kevin C. O'Kane
#+
#+     Kevin C. O'Kane
#+     anamfianna@earthlink.net
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

# clustertt.mps March 9, 2008

        kill ^clstr
        kill ^x

        open 1:"tmp,new"
        use 1
        for w1="":$order(^tt(w1)):"" do
        . for w2=w1:$order(^tt(w1,w2)):"" do
        .. write ^tt(w1,w2)," ",w1," ",w2,!
        close 1
        set %=$zsystem("sort -n -r < tmp > tmp.sorted")
        open 1:"tmp.sorted,old"
        set c=1
        for  do
        . use 1
        . read a  // correlation word1 word2
        . if '$test break
        . set score=$p(a," ",1)
        . set w1=$p(a," ",2)
        . set w2=$p(a," ",3)
        . if w1=w2 quit
        . set f=1

# ^x() is a two dimensional array that contains, at the second level,
# a list of clusters to which the word (w1) belongs
# ^cluster() is the cluster matrix.  Each row (s) is a cluster
# numbered 1,2,3 ... The second level is a list of the words
# in the cluster. 

# The following
# code runs thru all the clusters first for w1 (w1) and
# adds w2 to those clusters w1 belongs to.  It
# repeats the process for w2.  If a word pair are not
# assigned to some cluster (f=1), they are assigned to a new
# cluster and the cluster number is incremented (c)

        . if $d(^x(w1)) for s="":$order(^x(w1,s)):"" do
        .. set ^clstr(s,w2)=""
        .. set ^x(w2,s)=""
        .. set f=0

        . if $d(^x(w2)) for s="":$order(^x(w2,s)):"" do
        .. set ^clstr(s,w1)=""
        .. set ^x(w1,s)=""
        .. set f=0

        . if f do
        .. set ^clstr(c,w1)="" set ^x(w1,c)=""
        .. set ^clstr(c,w2)="" set ^x(w2,c)=""
        .. set c=c+1

# print the clusters

        close 1
        use 5
        write "number of clusters: ",c,!!
        for cx="":$order(^clstr(cx)):"" do
        . write cx," cluster",!
        . for w1="":$order(^clstr(cx,w1)):"" do
        .. use 5 write w1," "
        . write !!

