#!/usr/bin/mumps
#+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#+   
#+     Mumps ISR Software Library
#+     Copyright (C) 2005, 2006 by Kevin C. O'Kane  
#+
#+     Kevin C. O'Kane
#+     okane@cs.uni.edu
#+
#+
#+ This program is free software; you can redistribute it and/or modify
#+ it under the terms of the GNU General Public License as published by
#+ the Free Software Foundation; either version 2 of the License, or
#+ (at your option) any later version.
#+ 
#+ This program is distributed in the hope that it will be useful,
#+ but WITHOUT ANY WARRANTY; without even the implied warranty of
#+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#+ GNU General Public License for more details.
#+ 
#+ You should have received a copy of the GNU General Public License
#+ along with this program; if not, write to the Free Software
#+ Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#+
#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# medlineRetrieve.mps November 7, 2006

      open 1:"translated.txt,old"
      if '$test write "translated not found",! halt

      write "Enter query: "

      kill ^query
      kill ^ans
      kill ^tmp

      for  do                    // extract query words to query vector
      . set w=$zzscanalnum
      . if w="" break
      . set w=$zstem(w)
      . if '$data(^dict(w)) quit  // skip unknown words
      . set ^query(w)=1

# Find documents containing one or more query terms.


      . for d=$order(^index(w,d)) set ^tmp(d)=""  // retain doc id

      set time0=$zd1
      write !

      for i=$order(^tmp(i)) do  // calculate cosine between query and each doc
      . set c=$zzcosine(^doc(i),^query)   // MDH cosine calculation

# If cosine is > zero, put it and the doc offset (^doc(i)) into an answer vector.
# Make the cosine a right justified string of length 5 with 3 digits to the
# right of the decimal point.  This will force numeric ordering on the first key.

      . if c>0 set ^ans($justify(c,5,3),i)=""

      set x=""
      for %%=1:1:10 do  // display loop
      . set x=$order(^ans(x))
      . if x="" break
      . for i=$order(^ans(x,i)) do   // get the doc offsets for each cosine value.
      .. write x," ",^title(i),!

      write !,"Time used: ",$zd1-time0," seconds",!

